import 'package:jiffy/jiffy.dart';

import '../nsg_data.dart';

class NsgDataDateField extends NsgDataField {
  NsgDataDateField(String name) : super(name);
  @override
  dynamic get defaultValue => DateTime(1);

  @override
  dynamic convertJsonValue(dynamic jsonValue) {
    return DateTime.parse(jsonValue.toString());
  }

  @override
  dynamic convertToJson(dynamic jsonValue) {
    return jsonValue.toIso8601String();
    //(jsonValue as DateTime).microsecondsSinceEpoch;
  }

  @override
  void setValue(NsgFieldValues fieldValues, dynamic value) {
    if (value is String) {
      fieldValues.fields[name] = DateTime.parse(value);
    } else {
      fieldValues.fields[name] = value;
    }
  }

  @override
  String formattedValue(NsgDataItem item) {
    return NsgDateFormat.dateFormat(item[name]);
  }

  @override
  int compareTo(NsgDataItem a, NsgDataItem b) {
    var valueA = Jiffy(a.getFieldValue(name) as DateTime);
    var valueB = Jiffy(b.getFieldValue(name) as DateTime);
    return valueA.isAfter(valueB)
        ? 1
        : valueB.isAfter(valueA)
            ? -1
            : 0;
  }
}
